# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}

%define kversion %(echo %{kernel} | sed -e s/xen// -)
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%define kmach %(echo %{kernel} | perl -ne 'print "-$1" if /%{_target_cpu}\.(.+)/')

%if %(echo %{kernel} | grep -c xen)
        %{expand:%%define kxensufix -xen}
%endif

Summary: Telephony interface support for Allo GSM cards
Name: chan_allogsm
Version: 1.0.0.2
Release: 0%{?rcver:.rc%{rcver}}%{?dist}
License: GPL
Group: System Environment/Libraries
URL: http://www.allo.com
Source0: ftp://allo_gsm@61.12.17.162/r177/allo_gsm_driver.tar
Source1: allogsm
Patch0: allo_gsm_1.0.0.2-elastix-fixes.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: asterisk-devel
%if 0%{?fedora}%{?centos_ver}
BuildRequires: kernel%{?kxensufix}-devel-uname-r = %{kversion}
%else
BuildRequires: kernel%{?kxensufix}-devel = %{kversion}
%endif

%description

This package contains the Asterisk channel driver required to use the Allo GSM
driver.


%package -n kmod-allogsm%{?kxensufix}%{?kmach}
Summary: Kernel modules required for some Allo GSM hardware
Group: System Environment/Kernel
Requires: /sbin/depmod
%if 0%{?fedora}%{?centos_ver}
Requires(pre): module-init-tools
%else
Prereq: module-init-tools
%endif

%description -n kmod-allogsm%{?kxensufix}%{?kmach}
This package contains the dahdi kernel modules for the Linux kernel package :
%{kversion} (%{_target_cpu}%{?kxensufix:, XEN}).

%prep

%if "%{?kmach}" != ""
echo -e "\n\nCOMPILING for arch %{_target_cpu}%{kmach}\n\n"
%endif

%setup -n allo_gsm
tar -xf chan_gsm.tar
tar -xf PlxSdk.tar
%patch0 -p1

%build
BASEDIR_BUILD=`pwd`
cd PlxSdk/Linux/Driver
export KDIR=/lib/modules/%{kernel}/build
export PLX_SDK_DIR=$BASEDIR_BUILD/PlxSdk
./builddriver 9030 d
cd ../../..

cd chan_gsm/compat
make
cd ..
make chan_gsm.so
cd ..


%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_libdir}/asterisk/modules
cp `find . -name *.so` %{buildroot}%{_libdir}/asterisk/modules/
%{__mkdir_p} %{buildroot}%{_sysconfdir}/asterisk
cp chan_gsm/gsm*conf %{buildroot}%{_sysconfdir}/asterisk/

%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
cp %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/
chmod +x %{buildroot}%{_sysconfdir}/rc.d/init.d/*

%{__mkdir_p} %{buildroot}/lib/modules/%{kernel}/extra
cp `find . -name *.ko` %{buildroot}/lib/modules/%{kernel}/extra/
ls %{buildroot}/lib/modules/%{kernel}/extra/*.ko | sed -ne 's:^%{buildroot}::p' > %{buildroot}/lib/modules/%{kernel}/extra/.kmod-allogsm-%{version}-%{release}


%clean
%{__rm} -rf %{buildroot}

%post
/sbin/chkconfig --add allogsm
/sbin/chkconfig --level 2345 allogsm on


%post -n kmod-allogsm%{?kxensufix}%{?kmach}
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :
if [ -e /sbin/weak-modules ] ; then
	cat /lib/modules/%{kernel}/extra/.kmod-allogsm-%{version}-%{release} | /sbin/weak-modules --add-modules
else
	echo "WARN: /sbin/weak-modules not found, cannot associate with kernel updates!"
fi

%preun -n kmod-allogsm%{?kxensufix}%{?kmach}

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cp /lib/modules/%{kernel}/extra/.kmod-allogsm-%{version}-%{release} /tmp/
fi


%postun -n kmod-allogsm%{?kxensufix}%{?kmach}
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    if [ -e /sbin/weak-modules ] ; then
        cat /tmp/.kmod-allogsm-%{version}-%{release} | /sbin/weak-modules --remove-modules
    else
        echo "WARN: /sbin/weak-modules not found!"
    fi
    rm -f /tmp/.kmod-allogsm-%{version}-%{release}
fi


%files
%defattr(-, root, root, 0644)
%config(noreplace) %{_sysconfdir}/asterisk/*.conf
%defattr(-, root, root, 0755)
%{_libdir}/asterisk/modules/*.so
%{_sysconfdir}/rc.d/init.d/*

%files -n kmod-allogsm%{?kxensufix}%{?kmach}
%defattr(-, root, root, 0755)
/lib/modules/%{kernel}/extra/*.ko
/lib/modules/%{kernel}/extra/.kmod-allogsm-%{version}-%{release}

%changelog
* Mon Mar 04 2013 Alex Villacis Lasso <a_villacis@palosanto.com> - 1.0.0.2-0
- Initial release for Elastix.

